<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">
                        <h2>Ihre Kontaktinformationen</h2>
                    </div>

                    <div class="card-body">
                        <form ref="contactForm" @submit.prevent="submitContactForm">
                            <div class="form-group">
                                <label for="firstname">Vorname:</label>
                                <input type="text"
                                       id="firstname"
                                       class="form-control"
                                       name="firstname"
                                       v-model="form.firstname"
                                >
                                <span
                                    v-if="errors.firstname"
                                    role="alert"
                                    class="p-2 error-message"
                                >
                                    {{ errors["firstname"].join(' | ') }}
                               </span>
                            </div>

                            <div class="form-group mt-2">
                                <label for="lastname">Nachname:</label>
                                <input type="text"
                                       id="lastname"
                                       class="form-control"
                                       v-model="form.lastname"
                                >
                                <span
                                    v-if="errors.lastname"
                                    role="alert"
                                    class="p-2 error-message"
                                >
                                    {{ errors["lastname"].join(' | ') }}
                               </span>
                            </div>

                            <div class="form-group mt-2">
                                <label for="street">Straße:</label>
                                <input type="text"
                                       id="street"
                                       class="form-control"
                                       v-model="form.street"
                                >
                                <span
                                    v-if="errors.street"
                                    role="alert"
                                    class="p-2 error-message"
                                >
                                    {{ errors["street"].join(' | ') }}
                               </span>
                            </div>

                            <div class="form-group mt-2">
                                <label for="housenumber">Hausnummer:</label>
                                <input type="text"
                                       id="housenumber"
                                       class="form-control"
                                       v-model="form.housenumber"
                                >
                                <span
                                    v-if="errors.housenumber"
                                    role="alert"
                                    class="p-2 error-message"
                                >
                                    {{ errors["housenumber"].join(' | ') }}
                               </span>
                            </div>

                            <div class="form-group mt-2">
                                <label for="zip">PLZ:</label>
                                <input type="number"
                                       id="zip"
                                       minlength="5"
                                       maxlength="5"
                                       class="form-control"
                                       v-model="form.zip"
                                >
                                <span
                                    v-if="errors.zip"
                                    role="alert"
                                    class="p-2 error-message"
                                >
                                    {{ errors["zip"].join(' | ') }}
                               </span>
                            </div>

                            <div class="form-group mt-2">
                                <label for="city">Stadt:</label>
                                <input type="text"
                                       id="city"
                                       class="form-control"
                                       v-model="form.city"
                                >
                                <span
                                    v-if="errors.city"
                                    role="alert"
                                    class="p-2 error-message"
                                >
                                    {{ errors["city"].join(' | ') }}
                               </span>
                            </div>

                            <div class="form-group mt-2">
                                <label for="email">E-Mail:</label>
                                <input type="email"
                                       id="email"
                                       class="form-control"
                                       v-model="form.email"
                                >
                                <span
                                    v-if="errors.email"
                                    role="alert"
                                    class="p-2 error-message"
                                >
                                    {{ errors["email"].join(' | ') }}
                               </span>
                            </div>

                            <div class="form-group mt-2">
                                <label for="submit">&nbsp;</label>
                                <button class="btn btn-primary form-control">Senden</button>
                            </div>

                            <div v-if="success" class="p-2 text-success">
                                {{ success }}
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    data() {
        return {
            form: this.bootData(),
            errors: {},
            success: '',
            csrf: document.querySelector('meta[name="csrf-token"]').getAttribute('content'),
        }
    },
    methods: {
        // the initial data, that also get populated, when the save-call is completed successfully
        bootData() {
            return {
                firstname: '',
                lastname: '',
                street: '',
                housenumber: '',
                zip: '',
                city: '',
                email: '',
            };
        },
        submitContactForm() {
            axios.post('/send-contact-information', {
                firstname: this.form.firstname,
                lastname: this.form.lastname,
                street: this.form.street,
                housenumber: this.form.housenumber,
                zip: this.form.zip,
                city: this.form.city,
                email: this.form.email,
                _token: this.csrf,
                headers: {
                    'Content-Type': 'application/json',
                },
            }).then(response => {
                // console.log(response);
                // this.response = response.data
                this.success = 'Data saved successfully';
                this.response = JSON.stringify(response, null, 2)

                // resetting all entered data and remove errors
                this.errors = {};

                this.$refs.contactForm.reset();

                this.form = this.bootData();

                this.success = 'Erfolgreich gespeichert';
            }).catch(error => {
                this.response = 'Error: ' + error.response.status;
                this.errors = error.response.data.errors;
            })
        }
    }
}
</script>
